local function cclog(...)
    print(string.format(...))
end

local CHARACTER_MOVE_MIN_Y = 50;
local CHARACTER_MOVE_MAX_Y = 270;

function characterMoveMode ( character , deltaTime )
	local x = character:getPositionX();
	local y = character:getPositionY();
	local Offset = 50;
	local maxY = character:getBornPoint().y + Offset;
	if maxY > CHARACTER_MOVE_MAX_Y then
		maxY = CHARACTER_MOVE_MAX_Y;
	end
	local minY = character:getBornPoint().y - Offset;
	if minY < CHARACTER_MOVE_MIN_Y then
		minY = CHARACTER_MOVE_MIN_Y;
	end

	if character:getCharacterType() == CHARACTER_TYPE_PLAYER then
		x = character:getPositionX() + character:getMoveSpeed() * deltaTime;
		if x > character:getMoveTarget().x then
			x = character:getMoveTarget().x;
		end
	else
		x = character:getPositionX() - character:getMoveSpeed() * deltaTime;
		if x < character:getMoveTarget().x then
			x = character:getMoveTarget().x;
		end
	end

	if character:getMoveSpeed() == 0 and character:getUnitInfo().fYSpeed ~= 0 then
		if character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_UP then
			y = character:getPositionY() + deltaTime * character:getUnitInfo().fYSpeed;
			if y > CHARACTER_MOVE_MAX_Y then
				y = CHARACTER_MOVE_MAX_Y;
				character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_DOWN);
			end
		else
			y = character:getPositionY() - deltaTime * character:getUnitInfo().fYSpeed;
			if y < CHARACTER_MOVE_MIN_Y then
				y = CHARACTER_MOVE_MIN_Y;
				character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_UP);
			end
		end
	elseif character:getMoveSpeed() ~= 0 and character:getUnitInfo().fYSpeed ~= 0 then
		if character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_UP then
			y = character:getPositionY() + deltaTime * character:getUnitInfo().fYSpeed;
			if y > maxY then
				y = maxY;
				character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_DOWN);
			end
		else
			y = character:getPositionY() - deltaTime * character:getUnitInfo().fYSpeed;
			if y < minY then
				y = minY;
				character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_UP);
			end
		end
	end

	character:setPosition(ccp(x, y));
end

--[[function characterMoveNormal ( character , deltaTime )
	local x = 0;
	if character:getCharacterType() == CHARACTER_TYPE_PLAYER then
		x = character:getPositionX() + deltaTime * character:getMoveSpeed();
		if x > character:getMoveTarget().x then
			x = character:getMoveTarget().x
		end
	else
		x = character:getPositionX() - deltaTime * character:getMoveSpeed();
		if x < character:getMoveTarget().x then
			x = character:getMoveTarget().x
		end
	end

	character:setPositionX(x);
end

function characterMovePatrol ( character , deltaTime )
	local y = 0;
	if character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_UP then
		y = character:getPositionY() + deltaTime * character:getMoveSpeed();
		if y > CHARACTER_MOVE_MAX_Y then
			y = CHARACTER_MOVE_MAX_Y;
			character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_DOWN);
		end
	elseif character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_DOWN then
		y = character:getPositionY() - deltaTime * character:getMoveSpeed();
		if y < CHARACTER_MOVE_MIN_Y then
			y = CHARACTER_MOVE_MIN_Y;
			character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_UP);
		end
	end

	character:setPositionY(y);
end

function characterMovePath ( character , deltaTime )
	local x = character:getPositionX();
	local y = character:getPositionY();

	if character:getCharacterType() == CHARACTER_TYPE_PLAYER then
		x = character:getPositionX() + deltaTime * character:getMoveSpeed();
		if x > character:getMoveTarget().x then
			x = character:getMoveTarget().x
		end
	else
		x = character:getPositionX() - deltaTime * character:getMoveSpeed();
		if x < character:getMoveTarget().x then
			x = character:getMoveTarget().x
		end
	end

	if character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_UP then
		y = character:getPositionY() + deltaTime * character:getMoveSpeed();
		if y > CHARACTER_MOVE_MAX_Y then
			y = CHARACTER_MOVE_MAX_Y;
			character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_DOWN);
		end
	elseif character:getPatrolDirection() == CHARACTER_PATROL_DIRECTION_DOWN then
		y = character:getPositionY() - deltaTime * character:getMoveSpeed();
		if y < CHARACTER_MOVE_MIN_Y then
			y = CHARACTER_MOVE_MIN_Y;
			character:setPatrolDirection(CHARACTER_PATROL_DIRECTION_UP);
		end
	end

	character:setPosition(ccp(x, y));
end]]