local function cclog(...)
    print(string.format(...))
end

local timePass = 0
local slotNum = 7
local eStarCount = 0

--[[
    deltaTime       : float type, time delta between this frame and prev frame.
    fieldMinY       : int type, y-axis value for battle field bottom.
    fieldMaxY       : int type, y-axis value for battle field top.
    battleScene     : BattleScene type, you can use "createEnemy" function to create an enemy in battle field.
                      example: battleScene:createEnemy(10003, CCPointMake(0,CFUtils:getRandom(fieldMinY,fieldMaxY)), false)
    battleInput     : GLOBAL_BATTLE_INPUT type, all battle data sent from server is here.
    playerFields    : CCArray type, Character type inside, all player's characters in battle field.local 
                        例子：c = tolua.cast(playerFields:objectAtIndex(0), "Character")
                              print(c:getNPCID());
    playerTower     : MainTower type, player's main tower.
    enemyFields     : CCArray type, Character type inside, all enemy's characters in battle field.场上已创建的怪
    enemyTower      : MainTower type, enemy's main tower.
    
    
    TIPS: All available function can be read in common/tolua++ folder, use text editor open .pkg files.
    enemyAppear         ：怪出发点
    upside              ：上路，185,250
    middle              ：中路，120,185
    downside            ：下路，55,120
]]

--           id     scd   ucd
--           --     ---   --- 
local dog = {10002,   6,   20}
local cat = {10003,   3,   8}
local tiger = {10004,   10,   8}
local standByEnemy = {}     --敌人队列
local outEnemy = {}         
local enemyScd = {}
local enemyUcd = {}
local count = 0
local upside = 15           --设定出兵路数
local middle = 85
local downside = 100
local playerPets = {}
local atkTownPlayer = {}
local  boolean atkTown = false    ---是否要防守
local defCount        ---在轮塔的人数

--中路突破
function enemyCreater(deltaTime, fieldMinY, fieldMaxY, battleScene, battleInput, playerFields, playerTower, enemyFields, enemyTower)
   
  function PetAppear(Pet)   --判断出兵地点
    local enemyAppear = CFUtils:getRandom(0,100)
      if enemyAppear < upside then
         battleScene:createEnemy(standByEnemy[Pet].llInstanceID, CCPointMake(0,CFUtils:getRandom(fieldMaxY*0.65,         fieldMaxY)), 0)
      elseif enemyAppear >= upside and enemyAppear <= middle then
         battleScene:createEnemy(standByEnemy[Pet].llInstanceID, CCPointMake(0,CFUtils:getRandom(fieldMaxY*            0.35,fieldMaxY*0.7)), 0)
      elseif enemyAppear >= middle and enemyAppear <= downside then
         battleScene:createEnemy(standByEnemy[Pet].llInstanceID, CCPointMake(0,CFUtils:getRandom(fieldMinY,fieldMaxY*         0.35)), 0)
      end
  end
  
  function PetDefTown(Pet)
    --print("N人在轮",defCount)
    --local defPet = CFUtils:getRandom(1,defCount)
    --print("我来防守啦",defCount,atkTown,"出处",atkTownPlayer[defCount])
    battleScene:createEnemy(standByEnemy[Pet].llInstanceID, CCPointMake(0,atkTownPlayer[defCount]), 0)
   
   end
   
timePass = timePass + deltaTime

 --print:enemyTower()
 
if eStarCount~= nil then
    eStarCount = eStarCount + deltaTime    --设定一个出兵倒计时
end
if timePass > 1 then
        timePass = 0
        

  local oPCount = playerFields:count()
    atkTown = false
  
 if oPCount>0 then
   for pi =1,oPCount,1 do
     local c = tolua.cast(playerFields:objectAtIndex(pi-1), "Character")
     playerPets[pi] = c:getCharacterState()
     --print("我在干什么",playerPets[pi])
     if playerPets[pi] == 4  then
       local pAdd = c:getPositionY()
       atkTownPlayer[pi] = pAdd
       --print("attcking1","位置",pAdd)
       end
   end
   defCount = table.getn(atkTownPlayer)
   if defCount>0 then
     atkTown = true
     --print("我N人在轮你",defCount)
     --else atkTown = false
   end
  end

  if standByEnemy~=nil then                   
      for eSlotCount = 1,7,1 do
          if battleInput:getEnemySlot(eSlotCount-1).llInstanceID ~= 0 then
            standByEnemy[eSlotCount] = battleInput:getEnemySlot(eSlotCount-1)
          end
      end
      --print(eStarCount)
      local standByList = #standByEnemy
      if eStarCount~= nil then
        if eStarCount < 20000 then
          if(count<standByList) then
            for i = 1,standByList,1 do
              local enemyUnitInfo = GlobalData:sharedData():getUnitInfo(standByEnemy[i].uUnitID)
              enemyScd[i] = enemyUnitInfo.fStartCd + CFUtils:getRandom(2,5)        -----get敌人信息与使用CD
              enemyUcd[i] = enemyUnitInfo.fUseCd 
              count = count+1
            end
          end
          for i,v in pairs(enemyScd) do
             if v < eStarCount and outEnemy[i]~=standByEnemy[i].uUnitID then  -----出第一批敌人
               if atkTown == true and atkTownPlayer~= nil then
                 PetDefTown(i)
                 
               --print(standByEnemy[i].uUnitID,enemyScd)
                else PetAppear(i)
                outEnemy[i] = standByEnemy[i].uUnitID
                end
             end
          end
           
          for i,v in pairs(enemyUcd) do
             if math.floor(eStarCount)%v ==0 then                     -----后续出敌人
             if atkTown == true and atkTownPlayer~= nil then
                PetDefTown(i)
                --print(standByEnemy[i].uUnitID,enemyUcd)
                else local enemyAppear = CFUtils:getRandom(0,100)
                PetAppear(i)
                end
             end
          end
        else 
          eStarCount= nil
        end
      end
   end
 end
atkTownPlayer = {}
end

--playerFields:objectAtIndex(0):getCurrentHP()