local function cclog(...)
    print(string.format(...))
end

local slotNum = 7
local timePass = 0
local eStarCount = 0
local eOutCount = 0
--[[
    deltaTime       : float type, time delta between this frame and prev frame.
    fieldMinY       : int type, y-axis value for battle field bottom.
    fieldMaxY       : int type, y-axis value for battle field top.
    battleScene     : BattleScene type, you can use "createEnemy" function to create an enemy in battle field.
                      example: battleScene:createEnemy(10003, CCPointMake(0,CFUtils:getRandom(fieldMinY,fieldMaxY)), false)
    battleInput     : GLOBAL_BATTLE_INPUT type, all battle data sent from server is here.
    playerFields    : CCArray type, Character type inside, all player's characters in battle field.local 
                        例子：c = tolua.cast(playerFields:objectAtIndex(0), "Character")
                              print(c:getNPCID());
    playerTower     : MainTower type, player's main tower.
    enemyFields     : CCArray type, Character type inside, all enemy's characters in battle field.场上已创建的怪
    enemyTower      : MainTower type, enemy's main tower.
    
    
    TIPS: All available function can be read in common/tolua++ folder, use text editor open .pkg files.
    enemyAppear         ：怪出发点
    upside              ：上路，185,250
    middle              ：中路，120,185
    downside            ：下路，55,120
]]

--           id     scd   ucd
--           --     ---   --- 
-- 1-5

local enemyPet = {}
local playerPets = {}
local enemyOut = {}
local petCount = 0  --敌人种类数量
local time_count = 0
local boolean atkTown = false    ---是否要防守
local defCount = 0        ---在打塔的人数
local oPCount = 0   --场上我方数量
local  def70 = false 
local  def30 = false 

function enemyCreater(deltaTime, fieldMinY, fieldMaxY, battleScene, battleInput, playerFields, playerTower, enemyFields, enemyTower)
  timePass = timePass + deltaTime
  
  function PetDefTown(atkY,count)
   -- print(count,atkY)
    battleScene:createEnemy(enemyPet[count], CCPointMake(0,atkY), 0)
    end
        
  function enemyAppear1()      --出敌人方法1
    fieldMinY = CFUtils:getRandom(100,220)
      battleScene:createEnemy(enemyPet[1], CCPointMake(0,fieldMinY), 0)
      battleScene:createEnemy(enemyPet[2], CCPointMake(0,fieldMinY-40), 0)
  end

  function enemyAppear2()      --出敌人方法2
    fieldMinY = CFUtils:getRandom(100,220)
      battleScene:createEnemy(enemyPet[3], CCPointMake(0,fieldMinY), 0)
  end

  function enemyCount()        --统计敌人种类数量
    local standByEnemy = {}
    for eSlotCount = 1,slotNum,1 do
      if battleInput:getEnemySlot(eSlotCount-1).llInstanceID ~= 0 then
       standByEnemy[eSlotCount] = battleInput:getEnemySlot(eSlotCount-1)
       end
     end
    return table.getn(standByEnemy)  
   end


  local playerTowerHP = playerTower:getCurrentHP()
  local enemyTowerHP = enemyTower:getCurrentHP()
  local enemyTowerMHP = enemyTower:getMaxHP()
  if playerTowerHP == 0 or enemyTowerHP == 0 then
    eOutCount=0
  end
  
  if eStarCount~= nil then
    eStarCount = eStarCount + deltaTime    --设定一个出兵倒计时
   end
   --print(eOutCount)
   
  if timePass > 1 then
    eOutCount = eOutCount + 1
        timePass = 0
  
petCount = enemyCount()
oPCount = playerFields:count()
local atkTownPlayer = {}
 --atkTown = false


 if oPCount>0 then
   --print("我方数量",oPCount)
   for pi =1,oPCount,1 do
     local c = tolua.cast(playerFields:objectAtIndex(pi-1), "Character")
     playerPets[pi] = c:getCharacterState()
    -- print("我在干什么",playerPets[pi])
     if playerPets[pi] == 4  then
       local pAdd = c:getPositionY()
       table.insert(atkTownPlayer,pAdd)
       end
   end
   for i,v in pairs(atkTownPlayer) do
   --print("多少人在打",atkTownPlayer[i])
   end
   defCount = table.getn(atkTownPlayer)
   if defCount>0 then
     atkTown = true
     --print("我N人在轮你",defCount)
     else atkTown = false
   end
   --print(atkTown,defCount)
  end


  for i = 1,petCount,1 do     --拿敌人llInstanceID
    if battleInput:getEnemySlot(i-1).llInstanceID ~= 0 then
       enemyPet[i] = battleInput:getEnemySlot(i-1).llInstanceID
       --battleScene:createEnemy(enemyPet[i], CCPointMake(0,100), 0)
       --print(enemyPet[i])
       --local enemyUnitInfo = GlobalData:sharedData():getUnitInfo(enemyPet[i].uUnitID)
       --enemyOut[i] = enemyUnitInfo.uID
       --print(enemyOut[i])
     end
   end
   

--print(eOutCount)
   if eOutCount == 3  then      --第一波
      enemyAppear1()
    end

   if eOutCount == 5  then      --第一波第二段
      enemyAppear2()
    end
    
  
--后续出敌人
    if eOutCount%18==0 then
       enemyAppear1()
      end
    if eOutCount%20==0 then
       enemyAppear2()
      end
    if enemyTowerHP <=enemyTowerMHP*0.7 and def70 == false and defCount>1 then
       for i = 1,defCount-1,1 do
         --print(enemyTowerHP,"70%")
         PetDefTown(atkTownPlayer[i],i)
       end
       def70 = true
      end
      
     if enemyTowerHP <=enemyTowerMHP*0.4 and def30 == false then
       for i = 1,defCount,1 do
         --print(enemyTowerHP,"30%")
         PetDefTown(atkTownPlayer[i],i)
       end
       def30 = true
      end
  end
end



--playerFields:objectAtIndex(0):getCurrentHP()